; citac cw_out (c) 2003 OK2TEJ

; vstup kmitoctu na pinu 5 - GP2
; nf vystup na pinu 7 - GP0
; vstup AUTO (automaticke mereni) - GP1
; vstup MAN (zadost o kmitocet) - GP3

; krystal 4MHz                                       
	list p=12f629, r=DEC
	#include p12f629.inc

	__CONFIG _XT_OSC & _WDT_OFF & _PWRTE_ON & _MCLRE_OFF & _BODEN_ON

piptemp	equ	0x20
piplen	equ	0x21
cislo	equ	0x22
cislen	equ	0x23

freq	equ	0x24	; 2 byte pro frekvenci citace
freqold	equ	0x26
flag	equ	0x27

N10000	equ	0x28
N1000	equ	0x29
N100	equ	0x2A
N10	equ	0x2B
N1	equ	0x2C

intw	equ	0x2D	; zalohy pro int
ints	equ	0x2E

tmr0hi	equ	0x2F	; horni byte citace

tmrmer	equ	0x30	; casovac pro mereni konce zmeny freq

; io piny
NFOUT	equ	1		; GP0
AUTO	equ	1		; GP1
MAN	equ	3		; GP3

; konstanty
FREQ	equ	250		; frekvence cw
SPEED	equ	80		; rychlost cw
DELFRQ	equ	15		; pauza pred pipnutim frekvence v 1/8 sec

	org	0
	goto	start

	org	4
	movwf	intw
	movf	STATUS,w
	movwf	ints

	btfss	INTCON,T0IF
	goto	intt1

	bcf	INTCON,T0IF
	incf	tmr0hi,f	; horni byte frekvence (dolni je v TMR0
intend
	movf	ints,w
	movwf	STATUS
	swapf	intw,f
	swapf	intw,w
	retfie

intt1
	bcf	PIR1,TMR1IF
	movf	TMR0,w
	movwf	freq
	movf	tmr0hi,w
	movwf	freq+1
	clrwdt
	clrf	TMR0
	clrf	tmr0hi
	movlw	5			; konstanta pro frekvenci mereni 128ms (cca 8/sec)
; protoze kondiky 27p posouvaji rezonanci asi na 4.000118, je zmenena 9->5
	movwf	TMR1L
	movlw	6
	movwf	TMR1H		; TMR1 = 1536
	bsf	flag,0		; flag zmereno
	goto	intend

;===========================================================================
start
	bsf	STATUS,RP0
	clrwdt
	movlw	0x26		; GPPU=0, T0CS=1, PSA=0, PS=110
	movwf	OPTION_REG
	movlw	0x0E
	movwf	TRISIO		; GP1, GP2 a GP3 vstupn
	movlw	1
	movwf	PIE1		; TMR1IE=1
	movlw	0x02
	movwf	WPU			; pull-up odpory na AUTO (u MAN neni)
	bcf	STATUS,RP0
	movlw	0xE0
	movwf	INTCON		; GIE=1, PEIE=1, T0IE=1
	movlw	0x11
	movwf	T1CON		; TMR1GE=0, T1CKPS=01, T1OSCEN=0, TMR1CS=0, TMR1ON=1
	movlw	7
	movwf	CMCON		; vypnuti komparatoru
	bcf	flag,0
	clrf	TMR0		; vymazani frekvence
	clrf	tmr0hi
wait					; cekej na zmereni (prvni nemusi byt kompletni a proto ho ignoruj
	btfss	flag,0
	goto	wait
	bcf	flag,0
auto
	movlw	DELFRQ		; pri zapnuti nepipej, az pri zmene
	movwf	tmrmer		
	movf	freq,w		; zmena je 0
	movwf	freqold
main
	btfss	GPIO,MAN	; pokut neni aktivni MAN, preskoc
	call	putfreq

	btfsc	GPIO,AUTO	; pokud je aktivni AUTO, preskoc
	goto	auto

	btfss	flag,0		; cekej na zmereni
	goto	main
	bcf	flag,0		; cekej na presne zmereni

	movf	freq+1,f	; test na freq < 256 kHz (neni signal)
	skpnz
	goto	wait

	incf	tmrmer,f	; zvys pocet mereni bez zmeny freq
	movf	freq,w
	xorwf	freqold,f	; test na zmenu frekvence a aktualizace
	movwf	freqold
	skpnz
	goto	nozmen

	clrf	tmrmer		; cvakni jako zmena freq
	call	cvak

nozmen
	movf	tmrmer,w
	addlw	-DELFRQ
	skpc
	goto	main

	skpnz
	goto	pfreq

	decf	tmrmer,f
	goto	main

pfreq
	call	putfreq
	goto	main

;----------------------------------------------------
; odpipani cisla z freq
; pokud neni signal, tak jen kratce pipne
putfreq
	bcf	INTCON,GIE	; po dobu prevodu nepovol zmenu hodnoty
	movf	freq+1,f
	skpz
	goto	put
	movf	freq,f
	bsf	INTCON,GIE	; po dobu prevodu nepovol zmenu hodnoty
	skpnz
	goto	err
put	call	bin2dec999
;	movf	N10000,w
;	call	pipnum
;	movf	N1000,w
;	call	pipnum
;	movf	N100,w
;	call	pipnum
	movf	N10,w
	call	pipnum
	movf	N1,w
	call	pipnum
putend
	call	spc3
	call	spc3
	call	spc3
	return

err	call	pip
	goto	putend

; algoritmus Binaty-to-BCD od John Paysona
; pocita s cisly 0..65536
; num=A3*4096 + A2*256 + A1*16 + A0
; num=B4*10000 + B3*1000 + B2*100 + B1*10 + B0
; pr. 0x1234 - a_3=1, a_2=2, a_1=3, a_0=4
bin2dec999
	bcf	INTCON,GIE	; po dobu prevodu nepovol zmenu hodnoty

	movlw	253		; 7-10
	movwf	N10000

	swapf	freq+1,w
	andlw	0x0F	; w = a3
	addlw	240		; w = a3 - 16
	movwf	N1000
	addwf	N1000,f
	addwf	N1000,f
	addwf	N1000,f	; w = 4a3 - 64

	movf	freq+1,w
	andlw	0x0F
	addlw	233		; w = a2 - 23
	movwf	N100	; n100 = w
	addwf	N100,f	; n100 = 2a2 - 46
	swapf	freq+1,w
	andlw	0x0F	; w = a3
	addwf	N100,f	; n100 = 2a2 + a3 - 46

	movf	freq+1,w
	andlw	0x0F		; w = a_2
	addlw	233			; w = a_2 - 23
	movwf	N10
	addwf	N10,f		; Tens = 2 ( a_2 - 23 )
	addwf	N10,f		; Tens = 3 ( a_2 - 23 )
	movf	N10,w		; w = Tens
	addwf	N10,f		; Tens = 6 ( a_2 - 23 ) = 6*a_2 - 138
	swapf	freq,w
	andlw	0x0F		; w = a_1
	addwf	N10,f		; Tens = 6*a_2 + a_1 - 138
	addwf	N10,f		; Tens (b_1) = 6a_2 + 2a_1 - 138

	movwf	N1		; Ones = a_1
	movf	freq+1,w
	andlw	0x0F		; w = a_2
	addwf	N1,f		; Ones = a_2 + a_1
	swapf	freq+1,w
	andlw	0x0F		; w = a_3
	addwf	N1,w		; w = a_3 + a_2 + a_1
	sublw	251		; w = -5 - a_3 + a_2 + a_1
	movwf	N1		; Ones = w
	addwf	N1,f		; Ones = 2w
	addwf	N1,f		; Ones = 3w
	addwf	N1,f		; Ones = 4w
	movf	freq,w
	bsf	INTCON,GIE	; uz je moznot int
	andlw	0x0F
	addwf	N1,f		; b_0 = a_0 - 4(a_3 + a_2 + a_1) - 20

	movlw	10
bin2dec999a
	addwf	N1,f
	decf	N10,f
	skpc
	goto	bin2dec999a

bin2dec999b
	addwf	N10,f
	decf	N100,f
	skpc
	goto	bin2dec999b

bin2dec999c
	addwf	N100,f
	decf	N1000,f
	skpc
	goto	bin2dec999c

bin2dec999d
	addwf	N1000,f
	decf	N10000,f
	skpc
	goto	bin2dec999d

bin2dec999e
	addwf	N10000,f
	skpc
	goto	bin2dec999e

	return

;----------------------------------------------------
; odpipa cislo z W (delka = 5 tecek/carek)
pipnum
	call	morse
	movwf	cislo
	movlw	5		; 5 bitu
	movwf	cislen
piplp
	rrf	cislo,f
	skpnc
	call	pip2
	call	pip
	call	spc
	decfsz	cislen,f
	goto	piplp
	goto	spc3

; tabulka znaku pro cisla; 0=tecka, 1=carka
morse
	addwf	PCL,f
	retlw	0x1F	; 0
	retlw	0x1E    ; 1
	retlw	0x1C	; 2
	retlw	0x18	; 3
	retlw	0x10	; 4
	retlw	0x00	; 5
	retlw	0x01	; 6
	retlw	0x03	; 7
	retlw	0x07	; 8
	retlw	0x0F	; 9

;----------------------------------------------------
;generovani mezery a pipnuti (tecky) o 800Hz a cca 20wpm
pip2
	call	pip
pip	movlw	SPEED 		; smycka pipani - delka
	movwf	piplen
piplp2
	movlw	FREQ		; cekaci smycka - 625 cyklu
	movwf	piptemp
piplp1
	decfsz	piptemp,f
	goto	piplp1
	movlw	NFOUT
	xorwf	GPIO,f
	decfsz	piplen,f
	goto	piplp2
	return			

spc3
	call	spc
	call	spc
spc	movlw	SPEED 		; smycka pipani - delka
	movwf	piplen
spclp2
	movlw	FREQ		; cekaci smycka - 625 cyklu
	movwf	piptemp
spclp1
	decfsz	piptemp,f
	goto	spclp1
	nop
	nop
	decfsz	piplen,f
	goto	spclp2
	return			

cvak
	movlw	8 		; smycka pipani - delka
	movwf	piplen
cvaklp2
	movlw	FREQ		; cekaci smycka - 625 cyklu
	movwf	piptemp
cvaklp1
	decfsz	piptemp,f
	goto	cvaklp1
	movlw	NFOUT
	xorwf	GPIO,f
	decfsz	piplen,f
	goto	cvaklp2
	return			

	end
